
buildIndexStr=function(dialPlan, calledNbr){
    tmpNbr = calledNbr;
    if( "*" == calledNbr )  // javascript cannot support "*" in the ID.
    {
        tmpNbr="anyDest";
    }
    return "dialplan"+dialPlan+"callednbr"+tmpNbr;
};

getCCFeeMatrixListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.dialPlan, ev.calledNbr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.dialPlan+"</td>");
        $("#"+indexStr).append("<td>"+ev.calledNbr+"</td>");        
        $("#"+indexStr).append("<td>"+ev.rateID+"</td>");        
        $("#"+indexStr).append("<td>"+addBtnEdit(`editCCFeeMatrix('${ev.dialPlan}','${ev.calledNbr}')`)
                                       +addBtnDel(`delCCFeeMatrix('${ev.dialPlan}','${ev.calledNbr}')`)+"</td>");   
    });
    
};

getCCFeeMatrixList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/ccfeematrix/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getCCFeeMatrixListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getCCFeeMatrixList);
};

gotoNextList=function() {
    pageNext(getCCFeeMatrixList);
};

getCCFeeMatrixDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#dialPlan").val(ev.dialPlan);
        $("#calledNbr").val(ev.calledNbr);        
        $("#rateID").val(ev.rateID);
    });
};

getCCFeeMatrixDetail=function(dialPlan, calledNbr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("dialPlan", dialPlan)+",";
    jsonStr += jsonEncodeString("calledNbr", calledNbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/ccfeematrix/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getCCFeeMatrixDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateCCFeeMatrixDetail=function() {
    var jsonStr = "{";
            
    jsonStr += jsonEncodeString("dialPlan", $("#dialPlan").val())+",";
    jsonStr += jsonEncodeString("calledNbr", $("#calledNbr").val())+",";    
    jsonStr += jsonEncodeNumber("rateID", $("#rateID").val())+",";    
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/ccfeematrix/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiCCFeeMatrix.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiCCFeeMatrix.html");
        }
    });
};

delCCFeeMatrix=function(dialPlan, calledNbr) {    
    var indexStr = buildIndexStr(dialPlan, calledNbr)
    
    var jsonStr = "{";
    jsonStr += jsonEncodeString("dialPlan", dialPlan)+",";
    jsonStr += jsonEncodeString("calledNbr", calledNbr)
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/ccfeematrix/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiCCFeeMatrixDlg.html");
};

editCCFeeMatrix=function(dialPlan, calledNbr) {
    var dataPost = "dialPlan="+encodeURIComponent(dialPlan);   
    dataPost += "&calledNbr="+encodeURIComponent(calledNbr);   
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiCCFeeMatrixDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiCCFeeMatrix.html");
};
