buildIndexStr=function(ipAddr) {
    tmpStr = "ipAddr="+ipAddr;
    return hex_md5(tmpStr);
};

getEvtChannelAuthListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.ipAddr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.ipAddr+"</td>");
        $("#"+indexStr).append("<td>"+addBtnDel(`delEvtChannelAuth('${ev.ipAddr}')`)+"</td>");
    });
    
};

getEvtChannelAuthList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/evtchannelauth/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getEvtChannelAuthListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getEvtChannelAuthList);
};

gotoNextList=function() {
    pageNext(getEvtChannelAuthList);
};

delEvtChannelAuth=function(ipAddr) {    
    var indexStr = buildIndexStr(ipAddr);
    var jsonStr = "{";
    jsonStr += jsonEncodeString("ipAddr", ipAddr);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/evtchannelauth/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
            return
        },
        
        error: function(ev) {
            alertOperationFail();
            return
        }
    });
};

addEvtChannelAuth=function() {
    var jsonStr = "{";    
    jsonStr += jsonEncodeString("ipAddr",$("#ipAddr").val())+",";    
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/evtchannelauth/update",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiEvtChannelAuth.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiEvtChannelAuth.html");
        }
    });
};


/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiEvtChannelAuthDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiEvtChannelAuth.html");
};
