
getHGOperListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = ev.oper;
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.oper+"</td>");
        $("#"+indexStr).append("<td>"+ev.grpID+"</td>");
        $("#"+indexStr).append("<td>"+translateBclYesorNo(ev.autoInd)+"</td>");
        
        $("#"+indexStr).append("<td>"+addBtnDel(`delHGOper('${ev.oper}')`)+"</td>");
    });
    
};

getHGOperList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/hgoper/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getHGOperListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getHGOperList);
};

gotoNextList=function() {
    pageNext(getHGOperList);
};

updateHGOperDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeNumber("grpID", $("#grpID").val())+",";
    jsonStr += jsonEncodeString("oper", $("#oper").val())+",";    
    jsonStr += jsonEncodeNumber("autoInd", checkBoxIntVal("autoInd"))+",";
        
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/hgoper/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiHGOper.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiHGOper.html");
        }
    });
};

delHGOper=function(oper) {    
    var jsonStr = "{";
    jsonStr += jsonEncodeString("oper", oper)
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/hgoper/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+oper).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiHGOperDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiHGOper.html");
};
