nbrTranType2Str=function(type) {
    switch( type )
    {
        case 1:
            return "Add";
        
        case 2:
            return "Replace";
        
        case 3: 
            return "Delete";
            
        default:
            return "Unknown";        
    }
};

getNbrTransListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {
        var indexStr = ev.tranID;

        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        $("#"+indexStr).append("<td>"+ev.tranID+"</td>");
        $("#"+indexStr).append("<td>"+ev.description+"</td>");
        
        $("#"+indexStr).append("<td>"+nbrTranType2Str(ev.type) +"</td>");
        
        $("#"+indexStr).append("<td>"+ev.tranStart+"</td>");
        $("#"+indexStr).append("<td>"+ev.tranLen+"</td>");
        $("#"+indexStr).append("<td>"+ev.prefix+"</td>");
        
        $("#"+indexStr).append("<td>"+addBtnEdit(`editNbrTrans(${ev.tranID})`)
                                       +addBtnDel(`delNbrTrans(${ev.tranID})`)+"</td>");
    });
    
};

getNbrTransList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/natran/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getNbrTransListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getNbrTransList);
};

gotoNextList=function() {
    pageNext(getNbrTransList);
};

getNbrTransDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#tranID").val(ev.tranID);
        $("#description").val(ev.description);
        
        switch( ev.type )
        {
            case 1:            
                setInputChecked("typeAdd");
                break;
            
            case 2:
                setInputChecked("typeReplace");
                break;
                
            case 3:
                setInputChecked("typeDelete");
                break;
            
            default:
                setInputChecked("typeAdd");
                break;
        }
        
        $("#tranStart").val(ev.tranStart);
        $("#tranLen").val(ev.tranLen);
        $("#prefix").val(ev.prefix);
        
        updateUI();
    });
};

getNbrTransDetail=function(tran_id) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("tranID", tran_id);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/natran/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getNbrTransDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateNbrTransDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeNumber("tranID", $("#tranID").val())+",";
    
    if( inputHasChecked("typeAdd") )
    {
        jsonStr += jsonEncodeNumber("type", 1)+",";
    }
    else if( inputHasChecked("typeReplace")  )
    {
        jsonStr += jsonEncodeNumber("type", 2)+",";
    }
    else
    {
        jsonStr += jsonEncodeNumber("type", 3)+",";
    }
    
    jsonStr += jsonEncodeNumber("tranStart", $("#tranStart").val())+",";
    jsonStr += jsonEncodeNumber("tranLen", $("#tranLen").val())+",";
    
    jsonStr += jsonEncodeString("prefix", $("#prefix").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/natran/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiNbrTrans.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiNbrTrans.html");
        }
    });
};

delNbrTrans=function(tran_id) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("tranID", tran_id);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/natran/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {           
            $('#'+tran_id).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiNbrTransDlg.html");
};

editNbrTrans=function(tran_id) {
    var dataPost = "transID="+encodeURIComponent(tran_id);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiNbrTransDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiNbrTrans.html");
};
