buildIndexStr=function(dialPlan, cldNbr) {
    return hex_md5("dialPlan"+dialPlan+"cldNbr"+cldNbr);
};

getRGDetectionListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.dialPlan, ev.cldNbr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.dialPlan+"</td>");
        $("#"+indexStr).append("<td>"+ev.cldNbr+"</td>");      
        $("#"+indexStr).append("<td>"+ev.description+"</td>");   
        $("#"+indexStr).append("<td>"+ev.groupID+"</td>");  
        $("#"+indexStr).append("<td>"+addBtnEdit(`editRGDetection('${ev.dialPlan}','${ev.cldNbr}')`)
                                      +addBtnDel(`delRGDetection('${ev.dialPlan}','${ev.cldNbr}')`)+"</td>");
    });
    
};

getRGDetectionList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/rgdetection/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getRGDetectionListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getRGDetectionList);
};

gotoNextList=function() {
    pageNext(getRGDetectionList);
};

delRGDetection=function(dialPlan, cldNbr) {    
    var indexStr = buildIndexStr(dialPlan, cldNbr);
    var jsonStr = "{";
    jsonStr += jsonEncodeString("dialPlan", dialPlan)+",";
    jsonStr += jsonEncodeString("cldNbr", cldNbr);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/rgdetection/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateRGDetectionDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeString("dialPlan", $("#dialPlan").val())+",";
    jsonStr += jsonEncodeString("cldNbr", $("#cldNbr").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeNumber("groupID", $("#groupID").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/rgdetection/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiRGDetection.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiRGDetection.html");
        }
    });
};

getRGDetectionDetailResp=function(data) {
    $.each(data, function(index, ev) {      
        $("#description").val(ev.description);
        $("#groupID").val(ev.groupID);
    });
};

getRGDetectionDetail=function(dialPlan, cldNbr) {
    $("#dialPlan").val(dialPlan);
    $("#cldNbr").val(cldNbr);

    var jsonStr = "{";
    jsonStr += jsonEncodeString("dialPlan", dialPlan)+",";
    jsonStr += jsonEncodeString("cldNbr", cldNbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/rgdetection/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getRGDetectionDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiRGDetectionDlg.html");
};

editRGDetection=function(dialPlan, cldNbr) {    
    var dataPost = "dialPlan="+encodeURIComponent(dialPlan);
    dataPost += "&cldNbr="+encodeURIComponent(cldNbr);  
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiRGDetectionDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiRGDetection.html");
};
